(function() {
  var exec, fileUtil, findWildcardFiles, fs, path, watchFile, _;
  fileUtil = require('file');
  _ = require('underscore');
  _.mixin(require('underscore.string'));
  fs = require('fs');
  exec = require('child_process').exec;
  path = require('path');
  this.watch = function(file, task, callback) {
    var files, _i, _len, _results;
    if (_.isFunction(task)) {
      callback = task;
    }
    if (_.isRegExp(file)) {
      console.log(path.dirname(module.parent.filename));
      console.log(file.toString().replace(/\\\//g, '/'));
      return fileUtil.walkSync(path.dirname(module.parent.filename), function(root, flds, fls) {
        return console.log(fls);
      });
    } else if (file.indexOf('/*') !== -1) {
      files = findWildcardFiles(file);
      _results = [];
      for (_i = 0, _len = files.length; _i < _len; _i++) {
        file = files[_i];
        _results.push(watchFile(file, task, callback));
      }
      return _results;
    } else {
      if (!path.existsSync(file)) {
        throw new Error("SENTRY: File '" + file + "' does not exist!");
      }
      return watchFile(file, task, callback);
    }
  };
  watchFile = function(file, task, callback) {
    return fs.watchFile(file, function(curr, prev) {
      if (curr.size === prev.size && curr.mtime.getTime() === prev.mtime.getTime()) {
        return;
      }
      if (_.isString(task)) {
        return exec('cake stub', function(err, stdout, stderr) {
          return callback(err, stdout, stderr);
        });
      } else {
        return callback(file);
      }
    });
  };
  findWildcardFiles = function(file) {
    var ext, files, root, _i, _len, _ref;
    files = [];
    if ((file != null) && file.indexOf('**/*') !== -1) {
      root = file.split('**/*')[0];
      ext = file.split('**/*')[1];
      fileUtil.walkSync(root, function(root, flds, fls) {
        var file, _i, _len, _results;
        root = (root.charAt(root.length - 1) === '/' ? root : root + '/');
        _results = [];
        for (_i = 0, _len = fls.length; _i < _len; _i++) {
          file = fls[_i];
          _results.push((file.match(new RegExp(ext + '$')) != null) && _.indexOf(files, root + file) === -1 ? files.push(root + file) : void 0);
        }
        return _results;
      });
    } else if ((file != null) && file.indexOf('/*') !== -1) {
      root = file.split('/*')[0];
      ext = file.split('/*')[1];
      _ref = fs.readdirSync(root);
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        file = _ref[_i];
        if (file.indexOf('.') !== -1 && (file.match(new RegExp(ext + '$')) != null) && _.indexOf(files, root + '/' + file) === -1) {
          files.push(root + '/' + file);
        }
      }
    }
    return files;
  };
}).call(this);
